time limit per test2 seconds

memory limit per test256 megabytes

inputstandard input

outputstandard output

The ICM ACPC World Finals is coming! Unfortunately, the organizers of the competition were so busy preparing tasks that totally missed an important technical point — the organization of electricity supplement for all the participants workstations.

There are n computers for participants, the i-th of which has power equal to positive integer pi. At the same time there are m sockets available, the j-th of which has power euqal to positive integer sj. It is possible to connect the i-th computer to the j-th socket if and only if their powers are the same: pi = sj. It is allowed to connect no more than one computer to one socket. Thus, if the powers of all computers and sockets are distinct, then no computer can be connected to any of the sockets.

In order to fix the situation professor Puch Williams urgently ordered a wagon of adapters — power splitters. Each adapter has one plug and one socket with a voltage divider between them. After plugging an adapter to a socket with power x, the power on the adapter’s socket becomes equal to , it means that it is equal to the socket’s power divided by two with rounding up, for example and .

Each adapter can be used only once. It is possible to connect several adapters in a chain plugging the first to a socket. For example, if two adapters are plugged one after enother to a socket with power 10, it becomes possible to connect one computer with power 3 to this socket.

The organizers should install adapters so that it will be possible to supply with electricity the maximum number of computers c at the same time. If there are several possible connection configurations, they want to find the one that uses the minimum number of adapters u to connect c computers.

Help organizers calculate the maximum number of connected computers c and the minimum number of adapters u needed for this.

The wagon of adapters contains enough of them to do the task. It is guaranteed that it’s possible to connect at least one computer.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 200 000) — the number of computers and the number of sockets.

The second line contains n integers p1, p2, …, pn (1 ≤ pi ≤ 109) — the powers of the computers.

The third line contains m integers s1, s2, …, sm (1 ≤ si ≤ 109) — the power of the sockets.

Output

In the first line print two numbers c and u — the maximum number of computers which can at the same time be connected to electricity and the minimum number of adapters needed to connect c computers.

In the second line print m integers a1, a2, …, am (0 ≤ ai ≤ 109), where ai equals the number of adapters orginizers need to plug into the i-th socket. The sum of all ai should be equal to u.

In third line print n integers b1, b2, …, bn (0 ≤ bi ≤ m), where the bj-th equals the number of the socket which the j-th computer should be connected to. bj = 0 means that the j-th computer should not be connected to any socket. All bj that are different from 0 should be distinct. The power of the j-th computer should be equal to the power of the socket bj after plugging in abj adapters. The number of non-zero bj should be equal to c.

If there are multiple answers, print any of them.

Examples

input

2 2

1 1

2 2

output

2 2

1 1

1 2

input

2 1

2 100

99

output

1 6

6

1 0

【题解】



将插口按照power值升序排;

顺序处理每个power,如果有和当前处理的插头power相同的电脑。那么就把那个电脑插到这个插头上。如果没有,就一直除2,直到可以或power=0。为什么可以遇到就插上去呢?如果插在后面的插头,虽然可能也可以,但是必然要多耗费除2的次数(升序排的意义在此);而要满足除2次数最少则必然是这样的;

心里有些疑问吧

/*比如某个插头
power为8
同时有两个电脑power分别为4和1;
那我们肯定是把power为4的电脑插在这个插头上的(只除一次2);
而那个power为1的电脑,如果后面还有插头;
比如power=16;- >除4次;
总共5次
那是不是一开始power为8的的时候先插这个power为1的好点?
1 -> 8 :3次
后面4的时候
4 ->16:2次
总共5次
结果一样;
再试下 插头为32 64
电脑为2和16
先插16的
32
16 ->32 ->1
64
2->64 ->5 先插2的
32
2 -> 32 -> 4
64
16->64 >2
最后结果也是一样的;
但是如果没有后面那个插头显然先处理高power的更优;因为减少的次数少;
用map来快速判断有没有某个电脑的power的为x
*/
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map> using namespace std; const int MAXN = 300000; struct abc
{
int x, pos;
}; map <int, int> fre;
vector <int> v[MAXN];
int n, m, ans1[MAXN] = { 0 }, ans2[MAXN] = { 0 }, cnt = 0;
abc a[MAXN]; bool cmp(abc a, abc b)
{
return a.x < b.x;
} int main()
{
//freopen("F:\\rush.txt", "r", stdin);
scanf("%d%d", &n, &m);
for (int i = 1; i <= n; i++)
{
int x;
scanf("%d", &x);
int temp = fre[x];
if (temp == 0)
{
fre[x] = ++cnt;
v[cnt].push_back(i);
}
else
v[temp].push_back(i);
} for (int i = 1; i <= m; i++)
scanf("%d", &a[i].x), a[i].pos = i; sort(a + 1, a + 1 + m,cmp); int total = 0, num = 0;
for (int i = 1; i <= m; i++)
{
int sub = 0;
int x = a[i].x;
while (x)
{
int xx = fre[x];
if (xx)
{
int len = v[xx].size();
if (len)
{
int it = v[xx][len - 1];
ans2[it] = a[i].pos;
ans1[a[i].pos] = sub;
v[xx].pop_back();
total += sub;
num++;
break;
}
else
fre.erase(x);
}
if (x == 1)
break;
x = (x + 1) >> 1;
sub++;
}
}
printf("%d %d\n", num, total);
for (int i = 1; i <= m; i++)
printf("%d%c", ans1[i], i == m ? '\n' : ' ');
for (int i = 1; i <= n; i++)
printf("%d%c", ans2[i], i == n ? '\n' : ' ');
return 0;
}

【20.69%】【codeforces 732E】Sockets的更多相关文章

  1. 【 BowWow and the Timetable CodeForces - 1204A 】【思维】

    题目链接 可以发现 十进制4 对应 二进制100 十进制16 对应 二进制10000 十进制64 对应 二进制1000000 可以发现每多两个零,4的次幂就增加1. 用string读入题目给定的二进制 ...

  2. 【20.23%】【codeforces 740A】Alyona and copybooks

    time limit per test1 second memory limit per test256 megabytes inputstandard input outputstandard ou ...

  3. 【20.51%】【codeforces 610D】Vika and Segments

    time limit per test2 seconds memory limit per test256 megabytes inputstandard input outputstandard o ...

  4. 【codeforces 515C】Drazil and Factorial

    [题目链接]:http://codeforces.com/contest/515/problem/C [题意] 定义f(n)=n这个数各个位置上的数的阶乘的乘积; 给你a; 让你另外求一个不含0和1的 ...

  5. 【codeforces 766E】Mahmoud and a xor trip

    [题目链接]:http://codeforces.com/contest/766/problem/E [题意] 定义树上任意两点之间的距离为这条简单路径上经过的点; 那些点上的权值的所有异或; 求任意 ...

  6. 【codeforces 797E】Array Queries

    [题目链接]:http://codeforces.com/problemset/problem/797/E [题意] 给你一个n个元素的数组; 每个元素都在1..n之间; 然后给你q个询问; 每个询问 ...

  7. 【codeforces 509A】Maximum in Table

    [题目链接]:http://codeforces.com/contest/509/problem/A [题意] 给你一个递推式f[i][j] = f[i-1][j]+f[i][j-1]; 让你求f[i ...

  8. 【codeforces 757D】Felicity's Big Secret Revealed

    [题目链接]:http://codeforces.com/problemset/problem/757/D [题意] 给你一个01串; 让你分割这个01串; 要求2切..n+1切; 对于每一种切法 所 ...

  9. 【codeforces 760D】Travel Card

    [题目链接]:http://codeforces.com/contest/760/problem/D [题意] 去旅行,有3种类型的乘车票; 第一种:只能旅行一次20元 第二种:按时间计算,90分钟内 ...

随机推荐

  1. Jmeter--性能测试工具的搭建

    第一步:Jmeter软件下载第二步:解压下载的Jmeter包到某一盘符下,最好解压到无中文字符目录下,防止乱码问题,以我电脑为例,比如:D:tools第三步:找到解压的文件jmeter.bat,一般在 ...

  2. C# AutoMapper

    http://www.cnblogs.com/xlhblogs/p/3356748.html

  3. testng并发测试与测试并发

    一.testng并发测试 通过xml文件中suit结点的parallel属性指定,如 <suite name="bundle-module-testabc" parallel ...

  4. linux 安装完mysql 密码重置

    If you have forgot the MySQL root password, can’t remember or want to break in….. you can reset them ...

  5. SetForegroundWindow

    SetForegroundWindow 函数功能:该函数将创建指定窗口的线程设置到前台,并且激活该窗口.键盘输入转向该窗口,并为用户改各种可视的记号.系统给创建前台窗口的线程分配的权限稍高于其他线程. ...

  6. POJ 1562 Oil Deposits (HDU 1241 ZOJ 1562) DFS

    现在,又可以和她没心没肺的开着玩笑,感觉真好. 思念,是一种后知后觉的痛. 她说,今后做好朋友吧,说这句话的时候都没感觉.. 我想我该恨我自己,肆无忌惮的把她带进我的梦,当成了梦的主角. 梦醒之后总是 ...

  7. 【35.37%】【codeforces 556C】Case of Matryoshkas

    time limit per test2 seconds memory limit per test256 megabytes inputstandard input outputstandard o ...

  8. 【u116】最短路计数

    Time Limit: 1 second Memory Limit: 128 MB [问题描述] 给出一个N个顶点M条边的无向无权图,顶点编号为1-N.问从顶点1开始,到其他每个点的最短路有几条. [ ...

  9. Windows10终端优化方案:Ubuntu子系统+cmder+oh-my-zsh

    原问地址:https://zhuanlan.zhihu.com/p/34152045 最近从MacBook换到了种草已久的Surface Book 2,而我的工作环境也自然要从macOS换到Windo ...

  10. [Recompose] Render Nothing in Place of a Component using Recompose

    Learn how to use the ‘branch’ and ‘renderNothing’ higher-ordercomponents to render nothing when a ce ...